#include <stdio.h>
#include <stdlib.h>

char enter[2];

typedef struct TEditora {
	char cidade[30];
	char nome[30];
	struct TEditora *prox;
} *Editora;	

typedef struct TLivro {
	int codigo;
	char titulo[100];
	char autor[100];
	char dataPublicacao[11];
	int edicao;
	Editora editora;
	struct TLivro *prox;
} *Livro;

/* Lê do teclado os dados da editora e retorna a estrutura montada. */
Editora lerDadosEditora() {
	Editora e = (Editora)malloc(sizeof(struct TEditora));
	e->prox = NULL;
	printf("Informe os seguintes dados para cadastro da editora:\n");

	printf("Cidade: ");
	gets(e->cidade);

	printf("Nome: ");
	gets(e->nome);
	
	return e;
}

/* Calcula o tamanho da lista de editoras. */
int tamanhoLista(Editora lista) {
	int qtd = 0;
	
	// Conta quantos elementos tem na lista.
	while (lista) {
		qtd++;
		lista = lista->prox;
	}
	
	return qtd;
}

/* Recebe uma lista encadeada de editoras e retorna um vetor de editoras. */
Editora *transformarListaEmVetor(Editora lista, int tamanhoLista) {
	Editora *vetor;
	int i = 0;
	
	// Cria um vetor deste tamanho e copia os elementos da lista para ele.
	vetor = (Editora *)malloc(tamanhoLista * sizeof(struct TEditora *));
	while (lista) {
		vetor[i++] = lista;
		lista = lista->prox;
	}
	
	return vetor;
}

/* Escolhe uma editora do vetor de editoras. */
Editora escolherEditora(Editora* vetor, int tamVetor) {
	int i;
	printf("Editoras cadastradas:\n");
	
	for (i = 0; i < tamVetor; i++)
		printf("\t%d - %s (%s)\n", i, vetor[i]->nome, vetor[i]->cidade);
	
	printf("Digite o número da editora: ");
	scanf("%d", &i);
	gets(enter);
	return vetor[i];
}

/* Lê do teclado os dados do livro e retorna a estrutura montada. */
Livro lerDadosLivro(Editora *vetorEditoras, int tamVetorEditoras) {
	Livro l = (Livro)malloc(sizeof(struct TLivro));
	l->prox = NULL;
	printf("Informe os seguintes dados para cadastro do livro:\n");

	printf("Código: ");
	scanf("%d", &l->codigo);
	gets(enter);

	printf("Título: ");
	gets(l->titulo);

	printf("Autor: ");
	gets(l->autor);

	printf("Data de publicação: ");
	gets(l->dataPublicacao);

	printf("Edição: ");
	scanf("%d", &l->edicao);
	gets(enter);
	
	l->editora = escolherEditora(vetorEditoras, tamVetorEditoras);
	return l;
}

/* Imprime os dados do livro na tela. */
void imprimirLivro(Livro l) {
	printf("[%d] %s (%s)\n", l->codigo, l->titulo, l->autor);
	printf("\t-> %dª edição, publicada em %s por %s (%s)\n", l->edicao, l->dataPublicacao, l->editora->nome, l->editora->cidade);
}

main() {
	Livro prim, ult, atual;
	Editora primEd, ultEd, atualEd, *vetorEditoras;
	char resposta;
	int i = 0, qtdEditoras;
	
	// Cadastra primeiro as editoras (quantas quiser).
	primEd = ultEd = NULL;
	do {
		atualEd = lerDadosEditora();
		
		if (ultEd == NULL) primEd = ultEd = atualEd;
		else ultEd = ultEd->prox = atualEd;
		
		printf("\nDeseja cadastrar mais uma editora? (S/N) ");
		scanf("%c", &resposta);
		gets(enter);
	} while (resposta == 's' || resposta == 'S');
	
	// Converte a lista de editoras em um vetor para facilitar o acesso.
	qtdEditoras = tamanhoLista(primEd);
	vetorEditoras = transformarListaEmVetor(primEd, qtdEditoras);
	
	// Cadastra quantos livros quiser.
	prim = ult = NULL;
	do {
		atual = lerDadosLivro(vetorEditoras, qtdEditoras);
		
		if (ult == NULL) prim = ult = atual;
		else ult = ult->prox = atual;
		
		printf("\nDeseja cadastrar mais um livro? (S/N) ");
		scanf("%c", &resposta);
	} while (resposta == 's' || resposta == 'S');
	
	// Imprime os dados dos livros.
	atual = prim;
	while (atual) {
		printf("Livro %d:\n", ++i);
		imprimirLivro(atual);
		atual = atual->prox;
	}
}
