#include <stdio.h>
#include <stdlib.h>

char enter[2];

typedef struct TProduto {
	char nome[20];
	float preco;
	int qtd;
} *Produto;

/* Cadastra um novo produto no estoque. */
int cadastrarNovoProduto(Produto *estoque, int numProdutos) {
	Produto p = (Produto)malloc(sizeof(struct TProduto));
	
	// Obtém os dados do produto.
	printf("Nome: ");
	gets(p->nome);
	printf("Preço: ");
	scanf("%f", &p->preco);

	// O produto começa com 0 itens no estoque.
	p->qtd = 0;
	
	// Adiciona o produto ao estoque e retorna a nova quantidade de produtos.
	estoque[numProdutos++] = p;
	return numProdutos;
}

/* Registra que foi feita uma compra de um certo produto de um fornecedor, aumentando o estoque. */
void registrarCompra(Produto *estoque) {
	Produto p;
	int n;
	
	// Obtém o produto pelo código.
	printf("Código do produto: ");
	scanf("%d", &n);
	p = estoque[n];
	
	// Obtém a quantidade comprada e aumenta o estoque.
	printf("Registrando compra de \"%s\". Quantas unidades? ", p->nome);
	scanf("%d", &n);
	p->qtd += n;
}

/* Registra que foi feita uma venda de um certo produto a clientes, diminuindo o estoque. */
void registrarVenda(Produto *estoque) {
	Produto p;
	int n;
	
	// Obtém o produto pelo código.
	printf("Código do produto: ");
	scanf("%d", &n);
	p = estoque[n];
	
	// Obtém a quantidade vendida e diminui o estoque.
	printf("Registrando venda de \"%s\". Quantas unidades? ", p->nome);
	scanf("%d", &n);
	p->qtd -= n;
}

/* Imprime os produtos existentes, seus preços e quantidade em estoque. */
void imprimirEstoque(Produto *estoque, int numProdutos) {
	Produto p;
	int i;
	
	printf("\nEstado do estoque:\n");
	printf("Cod.\tNome\tPreço\t\tQuantidade\n");
	for (i = 0; i < numProdutos; i++) {
		p = estoque[i];
		printf("%02d\t%s\tR$ %02.2f\t\t%d\n", i, p->nome, p->preco, p->qtd);
	}
}

main() {
	int opcao = 0, numProdutos = 0;
	Produto estoque[50];
	
	do {
		// Imprime o menu de opções.
		printf("\n");
		printf("1 - Cadastrar novo produto;\n");
		printf("2 - Registrar compra de produto;\n");
		printf("3 - Registrar venda de produto;\n");
		printf("4 - Ver estado do estoque;\n");
		printf("5 - Sair.\n");
		printf("\nEscolha uma opção: ");
		scanf("%d", &opcao);
		gets(enter);
		
		// Verifica a opção escolhida:
		switch (opcao) {
		case 1:
			numProdutos = cadastrarNovoProduto(estoque, numProdutos);
			break;
			
		case 2:
			registrarCompra(estoque);
			break;
			
		case 3:
			registrarVenda(estoque);
			break;
			
		case 4:
			imprimirEstoque(estoque, numProdutos);
			break;
			
		case 5:
			break;
			
		default:
			printf("Opção inválida.\n");
		}
	} while (opcao != 5);
}